local balancer = require "ngx.balancer"

local upstream_ips = ngx.ctx.upstream_ips
if not upstream_ips then
    ngx.log(ngx.ERR, "No upstream IPs in context")
    return ngx.exit(500)
end

ngx.ctx.balancer_try = (ngx.ctx.balancer_try or 0) + 1
local try_index = ngx.ctx.balancer_try

if try_index > #upstream_ips then
    ngx.log(ngx.ERR, "All upstream IPs tried, none succeeded")
    return ngx.exit(500)
end

local ip = upstream_ips[try_index]
ngx.log(ngx.INFO, "Trying upstream IP: ", ip)

local ok, err = balancer.set_current_peer(ip, 443)
if not ok then
    ngx.log(ngx.ERR, "failed to set peer: ", err)
    return ngx.exit(500)
end
