local _M = {}

function _M.viewer_country()
    -- Maybe the CDN was nice and gave this to us
    local country = ngx.var.http_cloudfront_viewer_country or -- AWS CloudFront
                    ngx.var.http_fastly_client_country or     -- Fastly
                    ngx.var.http_cf_ipcountry                 -- CloudFlare
    if not country then return nil end
    return country:upper()

    -- TODO: Fallback to GeoIP lookup
end

function _M.needs_mirror(country)
    if not country then return true end

    -- TODO: Allow override of safe countries in host config

    local safe_countries = {
        US = true, -- United States
        GB = true, -- United Kingdom
        IE = true, -- Ireland
        FR = true, -- France
        DE = true, -- Germany
        NL = true, -- Netherlands
        BE = true, -- Belgium
        CH = true, -- Switzerland
        AT = true, -- Austria
        LU = true, -- Luxembourg
        LI = true, -- Liechtenstein
        MC = true, -- Monaco
        AD = true, -- Andorra
        ES = true, -- Spain
        PT = true, -- Portugal
        IT = true, -- Italy
        SM = true, -- San Marino
        VA = true, -- Vatican City
        MT = true, -- Malta
        NO = true, -- Norway
        SE = true, -- Sweden
        DK = true, -- Denmark
        FI = true, -- Finland
        IS = true  -- Iceland
    }
    if safe_countries[country] then return false end
    return true
end

return _M
