local utils = require "utils"

if ngx.ctx.jasima_config.rewrite_disable then
    return
end

if ngx.header["Content-Type"] then
    local content_type = ngx.header["Content-Type"]
    if content_type:find("text/html") or
       content_type:find("text/css") or
       content_type:find("text/xml") or
       content_type:find("application/javascript") or
       content_type:find("application/rss+xml") or
       content_type:find("application/atom+xml") or
       content_type:find("application/vnd.mpegurl") or
       content_type:find("application/x-mpegurl") then
        ngx.ctx.rewriting = true
        ngx.header["Content-Length"] = nil
    end
end

if ngx.header["Location"] then
    local pool_map = ngx.ctx.jasima_pool_map
    if ngx.ctx.rewriting and pool_map then
        local location = ngx.header["Location"]
        ngx.header["Location"] = location:gsub("//([a-zA-Z0-9%.%-]+%.[a-zA-Z0-9]+)/", utils.get_mirror)
    end
end
